//+------------------------------------------------------------------+
//|                                Daily range and locking trade.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

//---- input parameters
extern int        StartHour = 0;
extern int        SL = 50;
extern int        TP = 1000;
extern double     Lots=0.1;

extern int        fast_ema_period=12;
extern int        slow_ema_period=26;
extern int        signal_period=9;
extern int        applied_price=0;    
   //PRICE_CLOSE 0 Close price. 
   //PRICE_OPEN 1 Open price. 
   //PRICE_HIGH 2 High price. 
   //PRICE_LOW 3 Low price. 
   //PRICE_MEDIAN 4 Median price, (high+low)/2. 
   //PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
   //PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(DayOfWeek() == 1) return(0); // Don't trade on Monday
   
   int magic = 11111;
   int ticket, myTicket;
   static datetime myTime;
   
   if(Hour() == StartHour) // Time to put your orders
   {
      if(myTime != iTime(NULL,PERIOD_D1,0))
      {
         myTime = iTime(NULL,PERIOD_D1,0);
   
         double myMACD = iMACD(NULL, PERIOD_D1, fast_ema_period, slow_ema_period, signal_period, applied_price, MODE_MAIN, 0);
         double mySignal = iMACD(NULL, PERIOD_D1, fast_ema_period, slow_ema_period, signal_period, applied_price, MODE_SIGNAL, 0);
   
         if(myMACD > mySignal) 
         {
            ticket = OrderSend(Symbol(), OP_BUYLIMIT, Lots, Ask - 20*Point, 3, Bid - SL*Point, Bid + TP*Point, NULL, magic, myTime + 23*60*60, Green);
            ticket = OrderSend(Symbol(), OP_SELLLIMIT, Lots, Bid + 10*Point, 3, Ask + SL*Point, Ask - TP*Point, NULL, magic, myTime + 23*60*60, Red);
         } else {
            ticket = OrderSend(Symbol(), OP_BUYLIMIT, Lots, Ask - 10*Point, 3, Bid - SL*Point, Bid + TP*Point, NULL, magic, myTime + 23*60*60, Green);
            ticket = OrderSend(Symbol(), OP_SELLLIMIT, Lots, Bid + 20*Point, 3, Ask + SL*Point, Ask - TP*Point, NULL, magic, myTime + 23*60*60, Red);
         }
      }
   }
   
   if(TimeCurrent() > myTime + 23.5 * 60 * 60) 
   {
      if(OrdersTotal() > 0) 
      {
         for(int i=0;i<OrdersTotal();i++)
         {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
            {
               myTicket = OrderTicket();
               if(OrderType() == 0) OrderClose(myTicket,OrderLots(),Bid,3,Pink);
               if(OrderType() == 1) OrderClose(myTicket,OrderLots(),Ask,3,Pink);
            }
         }
      }
   }
   
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+